import 'bootstrap.css';
import '@mescius/wijmo.styles/wijmo.css';
import './styles.css';
//
import { RestCollectionViewOData } from './rest-collection-view-odata';
import { CollectionViewNavigator } from '@mescius/wijmo.input';
import { FlexGrid } from '@mescius/wijmo.grid';
import { FlexGridFilter } from '@mescius/wijmo.grid.filter';
//
document.readyState === 'complete' ? init() : window.onload = init;
//
function init() {
// Northwind OData service
let urlOData = 'https://services.odata.org/V4/Northwind/Northwind.svc';
// fields and columns to show
let fields = 'CustomerID,CompanyName,ContactName,ContactTitle,Address,City,Region,PostalCode,Country,Phone,Fax'.split(',');
// create the grid to show the data
let theGrid = new FlexGrid('#theGrid', {
isReadOnly: true,
showMarquee: true,
selectionMode: 'MultiRange',
deferResizing: true,
alternatingRowStep: 0,
// create RestCollectionViewOData
itemsSource: new RestCollectionViewOData(urlOData, 'Customers', {
fields: fields,
pageSize: 8,
sortDescriptions: ['CustomerID']
})
});
// auto-number row headers
theGrid.topLeftCells.columns[0].cellTemplate = $ => $.text || ($.row.index + 1).toString();
// add the filter
new FlexGridFilter(theGrid);
// add the navigator
new CollectionViewNavigator('#theNavigator', {
cv: theGrid.collectionView,
byPage: true
});
// toggle pagination
document.getElementById('paging').addEventListener('click', e => {
let paging = e.target.checked, view = theGrid.collectionView;
view.pageSize = paging ? 8 : 0;
});
}
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>MESCIUS Wijmo RestCollectionView OData</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- SystemJS -->
<script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.21.5/system.src.js" integrity="sha512-skZbMyvYdNoZfLmiGn5ii6KmklM82rYX2uWctBhzaXPxJgiv4XBwJnFGr5k8s+6tE1pcR1nuTKghozJHyzMcoA==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('./src/app');
</script>
</head>
<body>
<div class="container-fluid">
<label>
Paging
<input id="paging" type="checkbox" checked>
</label>
<br />
<div id="theNavigator"></div>
<div id="theGrid"></div>
</div>
</body>
</html>
body {
margin-bottom: 36pt;
}
.wj-flexgrid {
max-height: 400px;
}
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
return new (P || (P = Promise))(function (resolve, reject) {
function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
step((generator = generator.apply(thisArg, _arguments || [])).next());
});
};
import { RestCollectionView } from '@mescius/wijmo.rest';
import { DataType, DateTime, httpRequest, copy, changeType, isString, isDate, asString, asNumber, isNumber, asArray, assert } from '@mescius/wijmo';
// regex used to parse dates
const _rxDate = /^\d{4}\-\d{2}\-\d{2}T\d{2}\:\d{2}\:\d{2}|\/Date\([\d\-]*?\)/;
/**
* Class that extends {@link ServerCollectionViewBase} to support OData sources.
*/
export class RestCollectionViewOData extends RestCollectionView {
/**
* Initializes a new instance of the {@link RestCollectionViewOData} class.
*
* @param url Url of the OData service (for example
* 'https://services.odata.org/Northwind/Northwind.svc/').
* @param tableName Name of the table (entity) to retrieve from the service.
* If not provided, a list of the tables (entities) available is retrieved.
* @param options JavaScript object containing initialization data (property
* values and event handlers) for the {@link ODataCollectionView}.
*/
constructor(url, tableName, options) {
super();
this._odv = 4; // OData Version
this._url = asString(url, false);
this._tbl = asString(tableName);
copy(this, options);
}
/**
* Gets or sets an array containing the names of the key fields.
*
* Key fields are required for update operations (add/remove/delete).
*/
get keys() {
return this._keys;
}
set keys(value) {
this._keys = asArray(value);
}
/**
* Gets or sets the OData version to use.
*/
get odataVersion() {
return this._odv;
}
set odataVersion(value) {
this._odv = asNumber(value);
}
// ** implementation
// URL handling
_getServiceUrl() {
let url = this._url;
if (url[url.length - 1] != '/') {
url += '/';
}
return url;
}
_getReadUrl(link) {
let url = this._getServiceUrl();
if (link) {
url = link.indexOf('http') == 0 ? link : url + link;
}
else if (this._tbl) {
url += this._tbl;
}
return url;
}
_getWriteUrl(item) {
let url = this._getServiceUrl() + this._tbl;
if (item) {
assert(this.keys && this.keys.length > 0, 'write operations require keys.');
let keys = [];
this.keys.forEach(key => {
let itemKey = item[key];
if (itemKey == null) {
itemKey = '';
}
if (isString(itemKey)) { // enclose string keys in quotes
itemKey = '\'' + itemKey + '\'';
}
keys.push(this.keys.length == 1 // add key name only if we have multiple keys
? itemKey
: key + '=' + itemKey);
});
if (keys.length) {
url += '(' + keys.join(',') + ')';
}
}
return url;
}
// read parameters apply fields, sort, paging, and filter
_getReadParams(nextLink) {
let settings = {};
// we only do json
if (!nextLink || (nextLink.indexOf('$format') < 0 && nextLink.indexOf('%24format') < 0)) {
settings.$format = 'json';
}
// no parameters needed if they are already on the nextLink argument
if (!nextLink) {
// more setting if we have a table
if (this._tbl) {
// get filtered (but not paged) item count (OData4 uses $count, earlier versions use $inlinecount)
if (this._odv < 4) {
settings.$inlinecount = 'allpages';
}
else {
settings.$count = true;
}
// specify fields to retrieve
if (this.fields) {
settings.$select = this.fields.join(',');
}
// apply sort
if (this.sortOnServer && this.sortDescriptions.length) {
let sort = '';
this.sortDescriptions.forEach(sd => {
if (sort)
sort += ',';
sort += sd.property;
if (!sd.ascending)
sort += ' desc';
});
settings.$orderby = sort;
}
// apply paging
if (this.pageOnServer && this.pageSize > 0) {
settings.$skip = this.pageIndex * this.pageSize;
settings.$top = this.pageSize;
}
// apply filter
if (this.filterOnServer && this._filterProvider) {
settings.$filter = this._asODataFilter(this._filterProvider);
}
}
}
return settings;
}
// parse data
_jsonReviver(key, value) {
if (typeof value === 'string' && _rxDate.test(value)) {
value = value.indexOf('/Date(') == 0 // verbosejson
? new Date(parseInt(value.substr(6)))
: new Date(value);
}
return value;
}
// gets the OData filter definition from a wijmo.grid.filter.FlexGridFilter object.
// https://www.odata.org/documentation/odata-version-2-0/uri-conventions/
_asODataFilter(filter) {
let def = '';
for (let c = 0; c < filter.grid.columns.length; c++) {
let col = filter.grid.columns[c], cf = filter.getColumnFilter(col, false);
if (cf && cf.isActive) {
if (def) {
def += ' and ';
}
if (cf.conditionFilter && cf.conditionFilter.isActive) {
def += this._asODataConditionFilter(cf.conditionFilter);
}
else if (cf.valueFilter && cf.valueFilter.isActive) {
def += this._asODataValueFilter(cf.valueFilter);
}
}
}
return def;
}
_asODataValueFilter(vf) {
let col = vf.column, fld = col.binding, map = col.dataMap, def = '';
// build condition with 'eq/or'
for (let key in vf.showValues) {
let value = changeType(key, col.dataType, col.format);
if (map && isString(value)) { // TFS 239356
value = map.getKeyValue(value);
}
if (def)
def += ' or ';
def += this._asEquals(fld, value, col.dataType);
}
// enclose in parenthesis if not empty
if (def.length) {
def = '(' + def + ')';
}
// all done
return def;
}
_asEquals(fld, value, type) {
let def = '', DT = DataType;
if (value === '' || value == null) { // null or empty
def += fld + ' eq null';
if (type == DT.String) { // empty OK for strings only
def += ' or ' + fld + ' eq \'\'';
}
}
else if (type == DT.Date) { // non-null/empty dates (TFS 458080)
def += fld + ' ge ' + this._asODataValue(value, type) + ' and ' +
fld + ' lt ' + this._asODataValue(DateTime.addDays(value, 1), type);
}
else { // other types
def += fld + ' eq ' + this._asODataValue(value, type);
}
return '(' + def + ')';
}
_asODataConditionFilter(cf) {
let c1 = this._asODataCondition(cf, cf.condition1), c2 = this._asODataCondition(cf, cf.condition2);
if (c1 && c2)
return '(' + c1 + (cf.and ? ' and ' : ' or ') + c2 + ')';
if (c1)
return '(' + c1 + ')';
if (c2)
return '(' + c2 + ')';
return null;
}
_asODataCondition(cf, cnd) {
let col = cf.column, fld = col.binding, map = col.dataMap, value = cnd.value;
if (map && isString(value)) { // TFS 440901
value = map.getKeyValue(value);
}
value = this._asODataValue(value, cf.column.dataType);
switch (cnd.operator) {
case 0: // EQ = 0,
return fld + ' eq ' + value;
case 1: // NE = 1,
return fld + ' ne ' + value;
case 2: // GT = 2,
return fld + ' gt ' + value;
case 3: // GE = 3,
return fld + ' ge ' + value;
case 4: // LT = 4,
return fld + ' lt ' + value;
case 5: // LE = 5,
return fld + ' le ' + value;
case 6: // BW = 6,
return 'startswith(' + fld + ',' + value + ')';
case 7: // EW = 7,
return 'endswith(' + fld + ',' + value + ')';
case 8: // CT = 8,
return this._odv >= 4
? 'contains(' + fld + ',' + value + ')' // OData4
: 'substringof(' + value.toLowerCase() + ', tolower(' + fld + '))'; // OData2
case 9: // NC = 9
return this._odv >= 4
? 'not contains(' + fld + ',' + value + ')' // OData4
: 'not substringof(' + value.toLowerCase() + ', tolower(' + fld + '))'; // OData2
}
}
_asODataValue(value, dataType) {
if (isDate(value)) {
value = value.toJSON();
if (this._odv < 4) { // TFS 323961
value = "datetime'" + value.substr(0, 10) + "'";
}
return value;
}
else if (isString(value)) {
return "'" + value.replace(/'/g, "''") + "'";
}
else if (value != null) {
return value.toString();
}
return dataType == DataType.String ? "''" : null;
}
// convert objects before posting to OData services
_convertToDbFormat(item) {
if (this._odv >= 4) {
return item;
}
let obj = {};
for (let key in item) {
let value = item[key];
if (isNumber(value)) {
// convert numbers to strings in versions prior to 4.0.
// failing to do this may cause the service to throw an error:
// 'Cannot convert a primitive value to the expected type'
// which can in turn causes an HTTP 400 (Bad Request) error
value = value.toString();
}
obj[key] = value;
}
return obj;
}
// ** overrides
getItems(link) {
return __awaiter(this, void 0, void 0, function* () {
// cancel any pending requests
if (this._pendingRequest) {
//console.log('aborting pending request');
this._pendingRequest.abort();
}
return new Promise(resolve => {
this._pendingRequest = httpRequest(this._getReadUrl(link), {
requestHeaders: this.requestHeaders,
data: this._getReadParams(link),
success: (xhr) => __awaiter(this, void 0, void 0, function* () {
// parse response (handles OData4 and earlier)
let resp = JSON.parse(xhr.responseText, this._jsonReviver), arr = resp.d ? resp.d.results : resp.value, count = resp.d ? resp.d.__count : (resp['odata.count'] || resp['@odata.count']), nextLink = resp.d ? resp.d.__next : (resp['odata.nextLink'] || resp['@odata.nextLink']);
// update total item count
if (count != null) {
this._totalItemCount = isString(count) ? parseInt(count) : count;
}
// get data from next link
if (nextLink) {
let nextPage = yield this.getItems(nextLink);
arr = arr.concat(nextPage);
}
// done
resolve(arr);
}),
error: xhr => this._raiseError(xhr.responseText, false),
complete: xhr => this._pendingRequest = null // no pending requests
});
});
});
}
addItem(item) {
// write operations require keys
if (!this.keys || !this.keys.length) {
return null;
}
return new Promise(resolve => {
let url = this._getWriteUrl();
let requestHeaders = {
'Accept': 'application/json'
};
if (this.requestHeaders) {
for (let k in this.requestHeaders) {
requestHeaders[k] = this.requestHeaders[k];
}
}
httpRequest(url, {
method: 'POST',
requestHeaders: requestHeaders,
data: this._convertToDbFormat(item),
success: xhr => {
let newItem = JSON.parse(xhr.responseText, this._jsonReviver);
this.keys.forEach(key => {
item[key] = newItem[key];
});
this.refresh();
},
error: xhr => this._raiseError(xhr.responseText, true)
});
});
}
patchItem(item) {
// write operations require keys
if (!this.keys || !this.keys.length) {
return null;
}
return new Promise((resolve) => {
let url = this._getWriteUrl(this._edtClone);
httpRequest(url, {
method: 'PATCH',
requestHeaders: this.requestHeaders,
data: this._convertToDbFormat(item),
success: xhr => resolve(item),
error: xhr => this._raiseError(xhr.responseText, true)
});
});
}
deleteItem(item) {
// write operations require keys
if (!this.keys || !this.keys.length) {
return null;
}
return new Promise(resolve => {
let url = this._getWriteUrl(item);
httpRequest(url, {
method: 'DELETE',
requestHeaders: this.requestHeaders,
success: xhr => {
resolve(item);
},
error: xhr => this._raiseError(xhr.responseText, true)
});
});
}
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'jszip': 'npm:jszip/dist/jszip.js',
'@mescius/wijmo': 'npm:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'npm:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'npm:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'npm:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'npm:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'npm:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'npm:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'npm:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'npm:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'npm:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'npm:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'npm:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'npm:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'npm:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'npm:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'npm:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'npm:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'npm:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'npm:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'npm:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'npm:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.grouppanel': 'npm:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'npm:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'npm:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'npm:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'npm:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'npm:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'npm:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'npm:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'npm:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.nav': 'npm:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'npm:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'npm:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'npm:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'npm:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'npm:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'npm:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'npm:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'npm:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'npm:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.touch': 'npm:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'npm:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.barcode': 'npm:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'npm:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'npm:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'npm:@mescius/wijmo.barcode.specialized/index.js',
'jszip': 'npm:jszip/dist/jszip.js',
'bootstrap.css': 'npm:bootstrap/dist/css/bootstrap.min.css',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);

import 'bootstrap.css';
import '@mescius/wijmo.styles/wijmo.css';
import ReactDOM from 'react-dom/client';
import React, { useState } from 'react';
import { RestCollectionViewOData } from './rest-collection-view-odata';
import { CollectionViewNavigator } from '@mescius/wijmo.react.input';
import { FlexGrid } from '@mescius/wijmo.react.grid';
import { FlexGridFilter } from '@mescius/wijmo.react.grid.filter';
import './app.css';
const urlOData = 'https://services.odata.org/V4/Northwind/Northwind.svc';
const fields = 'CustomerID,CompanyName,ContactName,ContactTitle,Address,City,Region,PostalCode,Country,Phone,Fax'.split(',');
const view = new RestCollectionViewOData(urlOData, 'Customers', {
fields: fields,
pageSize: 8,
sortDescriptions: ['CustomerID']
});
function App() {
const [update, setUpdate] = useState(0);
return (<div className="container-fluid">
<label>
Paging{' '}
<input id="paging" type="checkbox" checked={view.pageSize > 0} onChange={e => {
view.pageSize = view.pageSize == 0 ? 8 : 0;
setUpdate(new Date().getTime());
}}>
</input>
</label>
<br />
<CollectionViewNavigator cv={view} byPage={true}/>
<FlexGrid isReadOnly={true} showMarquee={true} selectionMode='MultiRange' deferResizing={true} alternatingRowStep={0} itemsSource={view} initialized={(s) => s.topLeftCells.columns[0].cellTemplate = ($) => $.text || ($.row.index + 1).toString()}>
<FlexGridFilter />
</FlexGrid>
</div>);
}
const container = document.getElementById('app');
if (container) {
const root = ReactDOM.createRoot(container);
root.render(<App />);
}
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>MESCIUS Wijmo RestCollectionView OData</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- SystemJS -->
<script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.40/system.src.js" integrity="sha512-G6mEj6h18+m3MvzdviSDfPle/TfH0//cXcB33AKlNR/Rha0yQsKefDZKRTkIZos97HEGq2JMV1RT5ybMoQ3WsQ==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('./src/app');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
.wj-flexgrid {
max-height: 400px;
}
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
return new (P || (P = Promise))(function (resolve, reject) {
function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
step((generator = generator.apply(thisArg, _arguments || [])).next());
});
};
import { RestCollectionView } from '@mescius/wijmo.rest';
import { DataType, DateTime, httpRequest, copy, changeType, isString, isDate, asString, asNumber, isNumber, asArray, assert } from '@mescius/wijmo';
const _rxDate = /^\d{4}\-\d{2}\-\d{2}T\d{2}\:\d{2}\:\d{2}|\/Date\([\d\-]*?\)/;
/**
* Class that extends {@link ServerCollectionViewBase} to support OData sources.
*/
export class RestCollectionViewOData extends RestCollectionView {
/**
* Initializes a new instance of the {@link RestCollectionViewOData} class.
*
* @param url Url of the OData service (for example
* 'https://services.odata.org/Northwind/Northwind.svc/').
* @param tableName Name of the table (entity) to retrieve from the service.
* If not provided, a list of the tables (entities) available is retrieved.
* @param options JavaScript object containing initialization data (property
* values and event handlers) for the {@link ODataCollectionView}.
*/
constructor(url, tableName, options) {
super();
this._odv = 4; // OData Version
this._url = asString(url, false);
this._tbl = asString(tableName);
copy(this, options);
}
/**
* Gets or sets an array containing the names of the key fields.
*
* Key fields are required for update operations (add/remove/delete).
*/
get keys() {
return this._keys;
}
set keys(value) {
this._keys = asArray(value);
}
/**
* Gets or sets the OData version to use.
*/
get odataVersion() {
return this._odv;
}
set odataVersion(value) {
this._odv = asNumber(value);
}
// ** implementation
// URL handling
_getServiceUrl() {
let url = this._url;
if (url[url.length - 1] != '/') {
url += '/';
}
return url;
}
_getReadUrl(link) {
let url = this._getServiceUrl();
if (link) {
url = link.indexOf('http') == 0 ? link : url + link;
}
else if (this._tbl) {
url += this._tbl;
}
return url;
}
_getWriteUrl(item) {
let url = this._getServiceUrl() + this._tbl;
if (item) {
assert(this.keys && this.keys.length > 0, 'write operations require keys.');
let keys = [];
this.keys.forEach(key => {
let itemKey = item[key];
if (itemKey == null) {
itemKey = '';
}
if (isString(itemKey)) { // enclose string keys in quotes
itemKey = '\'' + itemKey + '\'';
}
keys.push(this.keys.length == 1 // add key name only if we have multiple keys
? itemKey
: key + '=' + itemKey);
});
if (keys.length) {
url += '(' + keys.join(',') + ')';
}
}
return url;
}
// read parameters apply fields, sort, paging, and filter
_getReadParams(nextLink) {
let settings = {};
// we only do json
if (!nextLink || (nextLink.indexOf('$format') < 0 && nextLink.indexOf('%24format') < 0)) {
settings.$format = 'json';
}
// no parameters needed if they are already on the nextLink argument
if (!nextLink) {
// more setting if we have a table
if (this._tbl) {
// get filtered (but not paged) item count (OData4 uses $count, earlier versions use $inlinecount)
if (this._odv < 4) {
settings.$inlinecount = 'allpages';
}
else {
settings.$count = true;
}
// specify fields to retrieve
if (this.fields) {
settings.$select = this.fields.join(',');
}
// apply sort
if (this.sortOnServer && this.sortDescriptions.length) {
let sort = '';
this.sortDescriptions.forEach(sd => {
if (sort)
sort += ',';
sort += sd.property;
if (!sd.ascending)
sort += ' desc';
});
settings.$orderby = sort;
}
// apply paging
if (this.pageOnServer && this.pageSize > 0) {
settings.$skip = this.pageIndex * this.pageSize;
settings.$top = this.pageSize;
}
// apply filter
if (this.filterOnServer && this._filterProvider) {
settings.$filter = this._asODataFilter(this._filterProvider);
}
}
}
return settings;
}
// parse data
_jsonReviver(key, value) {
if (typeof value === 'string' && _rxDate.test(value)) {
value = value.indexOf('/Date(') == 0 // verbosejson
? new Date(parseInt(value.substr(6)))
: new Date(value);
}
return value;
}
// gets the OData filter definition from a wijmo.grid.filter.FlexGridFilter object.
// https://www.odata.org/documentation/odata-version-2-0/uri-conventions/
_asODataFilter(filter) {
let def = '';
for (let c = 0; c < filter.grid.columns.length; c++) {
let col = filter.grid.columns[c], cf = filter.getColumnFilter(col, false);
if (cf && cf.isActive) {
if (def) {
def += ' and ';
}
if (cf.conditionFilter && cf.conditionFilter.isActive) {
def += this._asODataConditionFilter(cf.conditionFilter);
}
else if (cf.valueFilter && cf.valueFilter.isActive) {
def += this._asODataValueFilter(cf.valueFilter);
}
}
}
return def;
}
_asODataValueFilter(vf) {
let col = vf.column, fld = col.binding, map = col.dataMap, def = '';
// build condition with 'eq/or'
for (let key in vf.showValues) {
let value = changeType(key, col.dataType, col.format);
if (map && isString(value)) { // TFS 239356
value = map.getKeyValue(value);
}
if (def)
def += ' or ';
def += this._asEquals(fld, value, col.dataType);
}
// enclose in parenthesis if not empty
if (def.length) {
def = '(' + def + ')';
}
// all done
return def;
}
_asEquals(fld, value, type) {
let def = '', DT = DataType;
if (value === '' || value == null) { // null or empty
def += fld + ' eq null';
if (type == DT.String) { // empty OK for strings only
def += ' or ' + fld + ' eq \'\'';
}
}
else if (type == DT.Date) { // non-null/empty dates (TFS 458080)
def += fld + ' ge ' + this._asODataValue(value, type) + ' and ' +
fld + ' lt ' + this._asODataValue(DateTime.addDays(value, 1), type);
}
else { // other types
def += fld + ' eq ' + this._asODataValue(value, type);
}
return '(' + def + ')';
}
_asODataConditionFilter(cf) {
let c1 = this._asODataCondition(cf, cf.condition1), c2 = this._asODataCondition(cf, cf.condition2);
if (c1 && c2)
return '(' + c1 + (cf.and ? ' and ' : ' or ') + c2 + ')';
if (c1)
return '(' + c1 + ')';
if (c2)
return '(' + c2 + ')';
return null;
}
_asODataCondition(cf, cnd) {
let col = cf.column, fld = col.binding, map = col.dataMap, value = cnd.value;
if (map && isString(value)) { // TFS 440901
value = map.getKeyValue(value);
}
value = this._asODataValue(value, cf.column.dataType);
switch (cnd.operator) {
case 0: // EQ = 0,
return fld + ' eq ' + value;
case 1: // NE = 1,
return fld + ' ne ' + value;
case 2: // GT = 2,
return fld + ' gt ' + value;
case 3: // GE = 3,
return fld + ' ge ' + value;
case 4: // LT = 4,
return fld + ' lt ' + value;
case 5: // LE = 5,
return fld + ' le ' + value;
case 6: // BW = 6,
return 'startswith(' + fld + ',' + value + ')';
case 7: // EW = 7,
return 'endswith(' + fld + ',' + value + ')';
case 8: // CT = 8,
return this._odv >= 4
? 'contains(' + fld + ',' + value + ')' // OData4
: 'substringof(' + value.toLowerCase() + ', tolower(' + fld + '))'; // OData2
case 9: // NC = 9
return this._odv >= 4
? 'not contains(' + fld + ',' + value + ')' // OData4
: 'not substringof(' + value.toLowerCase() + ', tolower(' + fld + '))'; // OData2
}
}
_asODataValue(value, dataType) {
if (isDate(value)) {
value = value.toJSON();
if (this._odv < 4) { // TFS 323961
value = "datetime'" + value.substr(0, 10) + "'";
}
return value;
}
else if (isString(value)) {
return "'" + value.replace(/'/g, "''") + "'";
}
else if (value != null) {
return value.toString();
}
return dataType == DataType.String ? "''" : null;
}
// convert objects before posting to OData services
_convertToDbFormat(item) {
if (this._odv >= 4) {
return item;
}
let obj = {};
for (let key in item) {
let value = item[key];
if (isNumber(value)) {
// convert numbers to strings in versions prior to 4.0.
// failing to do this may cause the service to throw an error:
// 'Cannot convert a primitive value to the expected type'
// which can in turn causes an HTTP 400 (Bad Request) error
value = value.toString();
}
obj[key] = value;
}
return obj;
}
// ** overrides
getItems(link) {
return __awaiter(this, void 0, void 0, function* () {
// cancel any pending requests
if (this._pendingRequest) {
//console.log('aborting pending request');
this._pendingRequest.abort();
}
return new Promise(resolve => {
this._pendingRequest = httpRequest(this._getReadUrl(link), {
requestHeaders: this.requestHeaders,
data: this._getReadParams(link),
success: (xhr) => __awaiter(this, void 0, void 0, function* () {
// parse response (handles OData4 and earlier)
let resp = JSON.parse(xhr.responseText, this._jsonReviver), arr = resp.d ? resp.d.results : resp.value, count = resp.d ? resp.d.__count : (resp['odata.count'] || resp['@odata.count']), nextLink = resp.d ? resp.d.__next : (resp['odata.nextLink'] || resp['@odata.nextLink']);
// update total item count
if (count != null) {
this._totalItemCount = isString(count) ? parseInt(count) : count;
}
// get data from next link
if (nextLink) {
let nextPage = yield this.getItems(nextLink);
arr = arr.concat(nextPage);
}
// done
resolve(arr);
}),
error: xhr => this._raiseError(xhr.responseText, false),
complete: xhr => this._pendingRequest = null // no pending requests
});
});
});
}
addItem(item) {
// write operations require keys
if (!this.keys || !this.keys.length) {
return null;
}
return new Promise(resolve => {
let url = this._getWriteUrl();
let requestHeaders = {
'Accept': 'application/json'
};
if (this.requestHeaders) {
for (let k in this.requestHeaders) {
requestHeaders[k] = this.requestHeaders[k];
}
}
httpRequest(url, {
method: 'POST',
requestHeaders: requestHeaders,
data: this._convertToDbFormat(item),
success: xhr => {
let newItem = JSON.parse(xhr.responseText, this._jsonReviver);
this.keys.forEach(key => {
item[key] = newItem[key];
});
this.refresh();
},
error: xhr => this._raiseError(xhr.responseText, true)
});
});
}
patchItem(item) {
// write operations require keys
if (!this.keys || !this.keys.length) {
return null;
}
return new Promise((resolve) => {
let url = this._getWriteUrl(this._edtClone);
httpRequest(url, {
method: 'PATCH',
requestHeaders: this.requestHeaders,
data: this._convertToDbFormat(item),
success: xhr => resolve(item),
error: xhr => this._raiseError(xhr.responseText, true)
});
});
}
deleteItem(item) {
// write operations require keys
if (!this.keys || !this.keys.length) {
return null;
}
return new Promise(resolve => {
let url = this._getWriteUrl(item);
httpRequest(url, {
method: 'DELETE',
requestHeaders: this.requestHeaders,
success: xhr => {
resolve(item);
},
error: xhr => this._raiseError(xhr.responseText, true)
});
});
}
}
(function (global) {
window.process = {
env: {
NODE_ENV: "production"
}
}
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'jszip': 'npm:jszip/dist/jszip.js',
'@mescius/wijmo': 'npm:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'npm:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'npm:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'npm:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'npm:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'npm:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'npm:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'npm:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'npm:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'npm:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'npm:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'npm:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'npm:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'npm:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'npm:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'npm:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'npm:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'npm:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'npm:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'npm:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'npm:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'npm:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'npm:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'npm:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'npm:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'npm:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'npm:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'npm:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'npm:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'npm:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'npm:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.grid.immutable': 'npm:@mescius/wijmo.grid.immutable/index.js',
'@mescius/wijmo.touch': 'npm:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'npm:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.nav': 'npm:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'npm:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'npm:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'npm:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'npm:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'npm:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'npm:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'npm:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'npm:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'npm:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.barcode': 'npm:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'npm:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'npm:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'npm:@mescius/wijmo.barcode.specialized/index.js',
"@mescius/wijmo.react.chart.analytics": "npm:@mescius/wijmo.react.chart.analytics/index.js",
"@mescius/wijmo.react.chart.animation": "npm:@mescius/wijmo.react.chart.animation/index.js",
"@mescius/wijmo.react.chart.annotation": "npm:@mescius/wijmo.react.chart.annotation/index.js",
"@mescius/wijmo.react.chart.finance.analytics": "npm:@mescius/wijmo.react.chart.finance.analytics/index.js",
"@mescius/wijmo.react.chart.finance": "npm:@mescius/wijmo.react.chart.finance/index.js",
"@mescius/wijmo.react.chart.hierarchical": "npm:@mescius/wijmo.react.chart.hierarchical/index.js",
"@mescius/wijmo.react.chart.interaction": "npm:@mescius/wijmo.react.chart.interaction/index.js",
"@mescius/wijmo.react.chart.radar": "npm:@mescius/wijmo.react.chart.radar/index.js",
"@mescius/wijmo.react.chart": "npm:@mescius/wijmo.react.chart/index.js",
"@mescius/wijmo.react.core": "npm:@mescius/wijmo.react.core/index.js",
'@mescius/wijmo.react.chart.map': 'npm:@mescius/wijmo.react.chart.map/index.js',
"@mescius/wijmo.react.gauge": "npm:@mescius/wijmo.react.gauge/index.js",
"@mescius/wijmo.react.grid.detail": "npm:@mescius/wijmo.react.grid.detail/index.js",
"@mescius/wijmo.react.grid.filter": "npm:@mescius/wijmo.react.grid.filter/index.js",
"@mescius/wijmo.react.grid.grouppanel": "npm:@mescius/wijmo.react.grid.grouppanel/index.js",
'@mescius/wijmo.react.grid.search': 'npm:@mescius/wijmo.react.grid.search/index.js',
"@mescius/wijmo.react.grid.multirow": "npm:@mescius/wijmo.react.grid.multirow/index.js",
"@mescius/wijmo.react.grid.sheet": "npm:@mescius/wijmo.react.grid.sheet/index.js",
'@mescius/wijmo.react.grid.transposed': 'npm:@mescius/wijmo.react.grid.transposed/index.js',
'@mescius/wijmo.react.grid.transposedmultirow': 'npm:@mescius/wijmo.react.grid.transposedmultirow/index.js',
'@mescius/wijmo.react.grid.immutable': 'npm:@mescius/wijmo.react.grid.immutable/index.js',
"@mescius/wijmo.react.grid": "npm:@mescius/wijmo.react.grid/index.js",
"@mescius/wijmo.react.input": "npm:@mescius/wijmo.react.input/index.js",
"@mescius/wijmo.react.olap": "npm:@mescius/wijmo.react.olap/index.js",
"@mescius/wijmo.react.viewer": "npm:@mescius/wijmo.react.viewer/index.js",
"@mescius/wijmo.react.nav": "npm:@mescius/wijmo.react.nav/index.js",
"@mescius/wijmo.react.base": "npm:@mescius/wijmo.react.base/index.js",
'@mescius/wijmo.react.barcode.common': 'npm:@mescius/wijmo.react.barcode.common/index.js',
'@mescius/wijmo.react.barcode.composite': 'npm:@mescius/wijmo.react.barcode.composite/index.js',
'@mescius/wijmo.react.barcode.specialized': 'npm:@mescius/wijmo.react.barcode.specialized/index.js',
'jszip': 'npm:jszip/dist/jszip.js',
'react': 'npm:react/index.js',
'react-dom': 'npm:react-dom/index.js',
'react-dom/client': 'npm:react-dom/client.js',
"scheduler": "npm:scheduler/index.js",
'redux': 'npm:redux/dist/redux.min.js',
'react-redux': 'npm:react-redux/dist/react-redux.min.js',
'bootstrap.css': 'npm:bootstrap/dist/css/bootstrap.min.css',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js',
"react-use-event-hook": "npm:react-use-event-hook/dist/esm/useEvent.js",
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);

import 'bootstrap.css';
import '@mescius/wijmo.styles/wijmo.css';
import './styles.css';
//
import '@angular/compiler';
import { Component, Inject, enableProdMode, ɵresolveComponentResources } from '@angular/core';
import { BrowserModule, bootstrapApplication } from '@angular/platform-browser';
import { WjGridModule } from '@mescius/wijmo.angular2.grid';
import { WjGridFilterModule } from '@mescius/wijmo.angular2.grid.filter';
import { WjInputModule } from '@mescius/wijmo.angular2.input';
import { RestCollectionViewOData } from './rest-collection-view-odata';
//
// Northwind OData service
const urlOData = 'https://services.odata.org/V4/Northwind/Northwind.svc';
// fields to show on the grid
const fields = 'CustomerID,CompanyName,ContactName,ContactTitle,Address,City,Region,PostalCode,Country,Phone,Fax'.split(
',',
);
@Component({
standalone: true,
imports: [WjGridModule, WjGridFilterModule, WjInputModule, BrowserModule],
selector: 'app-component',
templateUrl: 'src/app.component.html',
})
export class AppComponent {
view = new RestCollectionViewOData(urlOData, 'Customers', {
fields: fields,
pageSize: 8,
sortDescriptions: ['CustomerID'],
});
//
// apply auto-numbering cell template
initGrid(theGrid: any) {
theGrid.topLeftCells.columns[0].cellTemplate = ($: any) => $.text || ($.row.index + 1).toString();
}
}
//
//
enableProdMode();
// Resolve resources (templateUrl, styleUrls etc), After resolution all URLs have been converted into `template` strings.
ɵresolveComponentResources(fetch).then(() => {
// Bootstrap application
bootstrapApplication(AppComponent).catch((err) => console.error(err));
});
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>MESCIUS Wijmo RestCollectionView OData</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- Polyfills -->
<script src="node_modules/core-js/client/shim.min.js"></script>
<script src="node_modules/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.21.5/system.src.js" integrity="sha512-skZbMyvYdNoZfLmiGn5ii6KmklM82rYX2uWctBhzaXPxJgiv4XBwJnFGr5k8s+6tE1pcR1nuTKghozJHyzMcoA==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<div class="container-fluid">
<label>
Paging
<input id="paging"
type="checkbox"
[checked]="view.pageSize > 0"
(change)="view.pageSize = view.pageSize == 0 ? 8 : 0">
</label>
<br />
<wj-collection-view-navigator
[cv]="view"
[byPage]="true">
</wj-collection-view-navigator>
<wj-flex-grid #theGrid
[isReadOnly]="true"
[showMarquee]="true"
[deferResizing]="true"
[alternatingRowStep]="0"
selectionMode="MultiRange"
[itemsSource]="view"
(initialized)="initGrid(theGrid)">
<wj-flex-grid-filter></wj-flex-grid-filter>
</wj-flex-grid>
</div>
body {
margin-bottom: 36pt;
}
.wj-flexgrid {
max-height: 400px;
}
import { RestCollectionView } from '@mescius/wijmo.rest';
import {
DataType, DateTime,
httpRequest, copy, changeType, isString, isDate, asString, asNumber, isNumber, asArray, assert
} from '@mescius/wijmo';
// regex used to parse dates
const _rxDate = /^\d{4}\-\d{2}\-\d{2}T\d{2}\:\d{2}\:\d{2}|\/Date\([\d\-]*?\)/;
/**
* Class that extends {@link ServerCollectionViewBase} to support OData sources.
*/
export class RestCollectionViewOData extends RestCollectionView {
_url: string;
_tbl: string;
_odv = 4; // OData Version
_pendingRequest: XMLHttpRequest;
/**
* Initializes a new instance of the {@link RestCollectionViewOData} class.
*
* @param url Url of the OData service (for example
* 'https://services.odata.org/Northwind/Northwind.svc/').
* @param tableName Name of the table (entity) to retrieve from the service.
* If not provided, a list of the tables (entities) available is retrieved.
* @param options JavaScript object containing initialization data (property
* values and event handlers) for the {@link ODataCollectionView}.
*/
constructor(url: string, tableName: string, options?: any) {
super();
this._url = asString(url, false);
this._tbl = asString(tableName);
copy(this, options);
}
/**
* Gets or sets an array containing the names of the key fields.
*
* Key fields are required for update operations (add/remove/delete).
*/
get keys(): string[] {
return this._keys;
}
set keys(value: string[]) {
this._keys = asArray(value);
}
/**
* Gets or sets the OData version to use.
*/
get odataVersion(): number {
return this._odv;
}
set odataVersion(value: number) {
this._odv = asNumber(value);
}
// ** implementation
// URL handling
_getServiceUrl() {
let url = this._url;
if (url[url.length - 1] != '/') {
url += '/';
}
return url;
}
_getReadUrl(link?: string) {
let url = this._getServiceUrl();
if (link) {
url = link.indexOf('http') == 0 ? link : url + link;
} else if (this._tbl) {
url += this._tbl;
}
return url;
}
private _getWriteUrl(item?: any): string {
let url = this._getServiceUrl() + this._tbl;
if (item) {
assert(this.keys && this.keys.length > 0, 'write operations require keys.');
let keys: string[] = [];
this.keys.forEach(key => {
let itemKey = item[key];
if (itemKey == null) {
itemKey = '';
}
if (isString(itemKey)) { // enclose string keys in quotes
itemKey = '\'' + itemKey + '\'';
}
keys.push(this.keys.length == 1 // add key name only if we have multiple keys
? itemKey
: key + '=' + itemKey);
});
if (keys.length) {
url += '(' + keys.join(',') + ')';
}
}
return url;
}
// read parameters apply fields, sort, paging, and filter
_getReadParams(nextLink?: string): any {
let settings: any = {};
// we only do json
if (!nextLink || (nextLink.indexOf('$format') < 0 && nextLink.indexOf('%24format') < 0)) {
settings.$format = 'json';
}
// no parameters needed if they are already on the nextLink argument
if (!nextLink) {
// more setting if we have a table
if (this._tbl) {
// get filtered (but not paged) item count (OData4 uses $count, earlier versions use $inlinecount)
if (this._odv < 4) {
settings.$inlinecount = 'allpages';
} else {
settings.$count = true;
}
// specify fields to retrieve
if (this.fields) {
settings.$select = this.fields.join(',');
}
// apply sort
if (this.sortOnServer && this.sortDescriptions.length) {
let sort = '';
this.sortDescriptions.forEach(sd => {
if (sort) sort += ',';
sort += sd.property;
if (!sd.ascending) sort += ' desc';
});
settings.$orderby = sort;
}
// apply paging
if (this.pageOnServer && this.pageSize > 0) {
settings.$skip = this.pageIndex * this.pageSize;
settings.$top = this.pageSize;
}
// apply filter
if (this.filterOnServer && this._filterProvider) {
settings.$filter = this._asODataFilter(this._filterProvider);
}
}
}
return settings;
}
// parse data
_jsonReviver(key: string, value: any): any {
if (typeof value === 'string' && _rxDate.test(value)) {
value = value.indexOf('/Date(') == 0 // verbosejson
? new Date(parseInt(value.substr(6)))
: new Date(value);
}
return value;
}
// gets the OData filter definition from a wijmo.grid.filter.FlexGridFilter object.
// https://www.odata.org/documentation/odata-version-2-0/uri-conventions/
_asODataFilter(filter: any): string {
let def = '';
for (let c = 0; c < filter.grid.columns.length; c++) {
let col = filter.grid.columns[c],
cf = filter.getColumnFilter(col, false);
if (cf && cf.isActive) {
if (def) {
def += ' and ';
}
if (cf.conditionFilter && cf.conditionFilter.isActive) {
def += this._asODataConditionFilter(cf.conditionFilter);
} else if (cf.valueFilter && cf.valueFilter.isActive) {
def += this._asODataValueFilter(cf.valueFilter);
}
}
}
return def;
}
_asODataValueFilter(vf: any): string {
let col = vf.column,
fld = col.binding,
map = col.dataMap,
def = '';
// build condition with 'eq/or'
for (let key in vf.showValues) {
let value = changeType(key, col.dataType, col.format);
if (map && isString(value)) { // TFS 239356
value = map.getKeyValue(value);
}
if (def) def += ' or ';
def += this._asEquals(fld, value, col.dataType);
}
// enclose in parenthesis if not empty
if (def.length) {
def = '(' + def + ')';
}
// all done
return def;
}
_asEquals(fld: string, value: any, type: DataType): string {
let def = '',
DT = DataType;
if (value === '' || value == null) { // null or empty
def += fld + ' eq null';
if (type == DT.String) { // empty OK for strings only
def += ' or ' + fld + ' eq \'\'';
}
} else if (type == DT.Date) { // non-null/empty dates (TFS 458080)
def += fld + ' ge ' + this._asODataValue(value, type) + ' and ' +
fld + ' lt ' + this._asODataValue(DateTime.addDays(value, 1), type);
} else { // other types
def += fld + ' eq ' + this._asODataValue(value, type);
}
return '(' + def + ')';
}
_asODataConditionFilter(cf: any): string {
let c1 = this._asODataCondition(cf, cf.condition1),
c2 = this._asODataCondition(cf, cf.condition2);
if (c1 && c2) return '(' + c1 + (cf.and ? ' and ' : ' or ') + c2 + ')';
if (c1) return '(' + c1 + ')';
if (c2) return '(' + c2 + ')';
return null;
}
_asODataCondition(cf: any, cnd: any): string {
let col = cf.column,
fld = col.binding,
map = col.dataMap,
value = cnd.value;
if (map && isString(value)) { // TFS 440901
value = map.getKeyValue(value);
}
value = this._asODataValue(value, cf.column.dataType);
switch (cnd.operator) {
case 0: // EQ = 0,
return fld + ' eq ' + value;
case 1: // NE = 1,
return fld + ' ne ' + value;
case 2: // GT = 2,
return fld + ' gt ' + value;
case 3: // GE = 3,
return fld + ' ge ' + value;
case 4: // LT = 4,
return fld + ' lt ' + value;
case 5: // LE = 5,
return fld + ' le ' + value;
case 6: // BW = 6,
return 'startswith(' + fld + ',' + value + ')';
case 7: // EW = 7,
return 'endswith(' + fld + ',' + value + ')';
case 8: // CT = 8,
return this._odv >= 4
? 'contains(' + fld + ',' + value + ')' // OData4
: 'substringof(' + value.toLowerCase() + ', tolower(' + fld + '))'; // OData2
case 9: // NC = 9
return this._odv >= 4
? 'not contains(' + fld + ',' + value + ')' // OData4
: 'not substringof(' + value.toLowerCase() + ', tolower(' + fld + '))'; // OData2
}
}
_asODataValue(value: any, dataType: DataType): string {
if (isDate(value)) {
value = value.toJSON();
if (this._odv < 4) { // TFS 323961
value = "datetime'" + value.substr(0, 10) + "'";
}
return value;
} else if (isString(value)) {
return "'" + value.replace(/'/g, "''") + "'";
} else if (value != null) {
return value.toString();
}
return dataType == DataType.String ? "''" : null;
}
// convert objects before posting to OData services
private _convertToDbFormat(item: any): any {
if (this._odv >= 4) {
return item;
}
let obj = {};
for (let key in item) {
let value = item[key];
if (isNumber(value)) {
// convert numbers to strings in versions prior to 4.0.
// failing to do this may cause the service to throw an error:
// 'Cannot convert a primitive value to the expected type'
// which can in turn causes an HTTP 400 (Bad Request) error
value = value.toString();
}
obj[key] = value;
}
return obj;
}
// ** overrides
protected async getItems(link?: string): Promise<any[]> {
// cancel any pending requests
if (this._pendingRequest) {
//console.log('aborting pending request');
this._pendingRequest.abort();
}
return new Promise<any[]>(resolve => {
this._pendingRequest = httpRequest(this._getReadUrl(link), {
requestHeaders: this.requestHeaders,
data: this._getReadParams(link),
success: async xhr => {
// parse response (handles OData4 and earlier)
let resp = JSON.parse(xhr.responseText, this._jsonReviver),
arr: any[] = resp.d ? resp.d.results : resp.value,
count: number | string = resp.d ? resp.d.__count : (resp['odata.count'] || resp['@odata.count']),
nextLink: string = resp.d ? resp.d.__next : (resp['odata.nextLink'] || resp['@odata.nextLink']);
// update total item count
if (count != null) {
this._totalItemCount = isString(count) ? parseInt(count) : count;
}
// get data from next link
if (nextLink) {
let nextPage = await this.getItems(nextLink);
arr = arr.concat(nextPage);
}
// done
resolve(arr);
},
error: xhr => this._raiseError(xhr.responseText, false),
complete: xhr => this._pendingRequest = null // no pending requests
});
});
}
protected addItem(item: any): Promise<any> {
// write operations require keys
if (!this.keys || !this.keys.length) {
return null;
}
return new Promise<any[]>(resolve => {
let url = this._getWriteUrl();
let requestHeaders = {
'Accept': 'application/json'
};
if (this.requestHeaders) {
for (let k in this.requestHeaders) {
requestHeaders[k] = this.requestHeaders[k];
}
}
httpRequest(url, {
method: 'POST',
requestHeaders: requestHeaders,
data: this._convertToDbFormat(item),
success: xhr => { // update keys in the new item, refresh the view
let newItem = JSON.parse(xhr.responseText, this._jsonReviver);
this.keys.forEach(key => {
item[key] = newItem[key];
});
this.refresh();
},
error: xhr => this._raiseError(xhr.responseText, true)
});
});
}
protected patchItem(item: any): Promise<any> {
// write operations require keys
if (!this.keys || !this.keys.length) {
return null;
}
return new Promise<any[]>((resolve) => {
let url = this._getWriteUrl(this._edtClone);
httpRequest(url, {
method: 'PATCH', //'PUT',
requestHeaders: this.requestHeaders,
data: this._convertToDbFormat(item),
success: xhr => resolve(item),
error: xhr => this._raiseError(xhr.responseText, true)
});
});
}
protected deleteItem(item: any): Promise<any> {
// write operations require keys
if (!this.keys || !this.keys.length) {
return null;
}
return new Promise<any[]>(resolve => {
let url = this._getWriteUrl(item);
httpRequest(url, {
method: 'DELETE',
requestHeaders: this.requestHeaders,
success: xhr => {
resolve(item);
},
error: xhr => this._raiseError(xhr.responseText, true)
});
});
}
}
(function (global) {
SystemJS.config({
transpiler: './plugin-typescript.js',
typescriptOptions: {
"target": "ES2022",
"module": "system",
"emitDecoratorMetadata": true,
"experimentalDecorators": true,
},
baseURL: 'node_modules/',
meta: {
'typescript': {
"exports": "ts"
},
'*.css': { loader: 'systemjs-plugin-css' },
'*.mjs': {
format: 'esm'
},
},
paths: {
// paths serve as alias
'npm:': ''
},
packageConfigPaths: [
'/node_modules/*/package.json',
"/node_modules/@angular/*/package.json",
"/node_modules/@mescius/*/package.json"
],
map: {
'core-js': 'https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js',
'typescript': 'https://cdnjs.cloudflare.com/ajax/libs/typescript/5.2.2/typescript.min.js',
"rxjs": "https://cdnjs.cloudflare.com/ajax/libs/rxjs/7.8.1/rxjs.umd.min.js",
'systemjs-plugin-css': 'https://cdn.jsdelivr.net/npm/systemjs-plugin-css@0.1.37/css.js',
'@mescius/wijmo': 'npm:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'npm:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'npm:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'npm:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'npm:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'npm:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'npm:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'npm:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'npm:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'npm:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'npm:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'npm:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'npm:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'npm:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'npm:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'npm:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'npm:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'npm:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'npm:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'npm:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'npm:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'npm:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'npm:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'npm:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'npm:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'npm:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'npm:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'npm:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'npm:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'npm:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'npm:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.nav': 'npm:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'npm:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'npm:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'npm:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'npm:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'npm:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'npm:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'npm:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'npm:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'npm:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.touch': 'npm:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'npm:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.barcode': 'npm:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'npm:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'npm:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'npm:@mescius/wijmo.barcode.specialized/index.js',
"@mescius/wijmo.angular2.chart.analytics": "npm:@mescius/wijmo.angular2.chart.analytics/index.js",
"@mescius/wijmo.angular2.chart.animation": "npm:@mescius/wijmo.angular2.chart.animation/index.js",
"@mescius/wijmo.angular2.chart.annotation": "npm:@mescius/wijmo.angular2.chart.annotation/index.js",
"@mescius/wijmo.angular2.chart.finance.analytics": "npm:@mescius/wijmo.angular2.chart.finance.analytics/index.js",
"@mescius/wijmo.angular2.chart.finance": "npm:@mescius/wijmo.angular2.chart.finance/index.js",
"@mescius/wijmo.angular2.chart.hierarchical": "npm:@mescius/wijmo.angular2.chart.hierarchical/index.js",
"@mescius/wijmo.angular2.chart.interaction": "npm:@mescius/wijmo.angular2.chart.interaction/index.js",
"@mescius/wijmo.angular2.chart.radar": "npm:@mescius/wijmo.angular2.chart.radar/index.js",
'@mescius/wijmo.angular2.chart.map': 'npm:@mescius/wijmo.angular2.chart.map/index.js',
"@mescius/wijmo.angular2.chart": "npm:@mescius/wijmo.angular2.chart/index.js",
"@mescius/wijmo.angular2.core": "npm:@mescius/wijmo.angular2.core/index.js",
"@mescius/wijmo.angular2.gauge": "npm:@mescius/wijmo.angular2.gauge/index.js",
"@mescius/wijmo.angular2.grid.detail": "npm:@mescius/wijmo.angular2.grid.detail/index.js",
"@mescius/wijmo.angular2.grid.filter": "npm:@mescius/wijmo.angular2.grid.filter/index.js",
"@mescius/wijmo.angular2.grid.grouppanel": "npm:@mescius/wijmo.angular2.grid.grouppanel/index.js",
"@mescius/wijmo.angular2.grid.search": "npm:@mescius/wijmo.angular2.grid.search/index.js",
"@mescius/wijmo.angular2.grid.multirow": "npm:@mescius/wijmo.angular2.grid.multirow/index.js",
"@mescius/wijmo.angular2.grid.sheet": "npm:@mescius/wijmo.angular2.grid.sheet/index.js",
'@mescius/wijmo.angular2.grid.transposed': 'npm:@mescius/wijmo.angular2.grid.transposed/index.js',
'@mescius/wijmo.angular2.grid.transposedmultirow': 'npm:@mescius/wijmo.angular2.grid.transposedmultirow/index.js',
"@mescius/wijmo.angular2.grid": "npm:@mescius/wijmo.angular2.grid/index.js",
"@mescius/wijmo.angular2.input": "npm:@mescius/wijmo.angular2.input/index.js",
"@mescius/wijmo.angular2.olap": "npm:@mescius/wijmo.angular2.olap/index.js",
"@mescius/wijmo.angular2.viewer": "npm:@mescius/wijmo.angular2.viewer/index.js",
"@mescius/wijmo.angular2.nav": "npm:@mescius/wijmo.angular2.nav/index.js",
"@mescius/wijmo.angular2.directivebase": "npm:@mescius/wijmo.angular2.directivebase/index.js",
'@mescius/wijmo.angular2.barcode.common': 'npm:@mescius/wijmo.angular2.barcode.common/index.js',
'@mescius/wijmo.angular2.barcode.composite': 'npm:@mescius/wijmo.angular2.barcode.composite/index.js',
'@mescius/wijmo.angular2.barcode.specialized': 'npm:@mescius/wijmo.angular2.barcode.specialized/index.js',
'bootstrap.css': 'npm:bootstrap/dist/css/bootstrap.min.css',
'jszip': 'https://cdnjs.cloudflare.com/ajax/libs/jszip/3.10.1/jszip.min.js',
'@angular/core': 'npm:@angular/core/fesm2022/core.mjs',
'@angular/core/primitives/signals': 'npm:@angular/core/fesm2022/primitives/signals.mjs',
'@angular/core/primitives/event-dispatch': 'npm:@angular/core/fesm2022/primitives/event-dispatch.mjs',
'@angular/common': 'npm:@angular/common/fesm2022/common.mjs',
'@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs',
'@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs',
'@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs',
'@angular/http': 'npm:@angular/http/fesm2022/http.mjs',
'@angular/router': 'npm:@angular/router/fesm2022/router.mjs',
'@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs',
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
"./src": {
defaultExtension: 'ts'
},
"node_modules": {
defaultExtension: 'js'
},
wijmo: {
defaultExtension: 'js',
}
}
});
})(this);

<template>
<div className="container-fluid">
<label>
Paging
<input id="paging" type="checkbox" :checked="view.pageSize > 0"
v-on:click="view.pageSize = view.pageSize == 0 ? 8 : 0">
</label>
<br />
<wj-collection-view-navigator :cv="view" :byPage="true" />
<wj-flex-grid :isReadOnly="true" :showMarquee="true" :deferResizing="true" :alternatingRowStep="0"
selectionMode="MultiRange" :itemsSource="view" :initialized="initGrid">
<wj-flex-grid-filter />
</wj-flex-grid>
</div>
</template>
<script setup>
import { RestCollectionViewOData } from "./rest-collection-view-odata";
import { ref } from "vue";
// Northwind OData service
const urlOData = 'https://services.odata.org/V4/Northwind/Northwind.svc';
// fields and columns to show
const fields = 'CustomerID,CompanyName,ContactName,ContactTitle,Address,City,Region,PostalCode,Country,Phone,Fax'.split(',');
const view = ref(
new RestCollectionViewOData(urlOData, "Customers", {
fields: fields,
pageSize: 8,
sortDescriptions: ["CustomerID"],
}),
);
function initGrid(s) {
s.topLeftCells.columns[0].cellTemplate = function ($) {
return $.text || ($.row.index + 1).toString();
};
}
</script>
<style>
body {
margin-bottom: 36pt;
}
.wj-flexgrid {
max-height: 400px;
}
</style>
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>MESCIUS Wijmo RestCollectionView OData</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- SystemJS -->
<script src="compiler.js" type="module"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.21.5/system.src.js" integrity="sha512-skZbMyvYdNoZfLmiGn5ii6KmklM82rYX2uWctBhzaXPxJgiv4XBwJnFGr5k8s+6tE1pcR1nuTKghozJHyzMcoA==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('./src/app.js');
</script>
</head>
<body>
<div id="app">
</div>
</body>
</html>
import { RestCollectionView } from '@mescius/wijmo.rest';
import {
DataType, DateTime,
httpRequest, copy, changeType, isString, isDate, asString, asNumber, isNumber, asArray, assert
} from '@mescius/wijmo';
// regex used to parse dates
const _rxDate = /^\d{4}\-\d{2}\-\d{2}T\d{2}\:\d{2}\:\d{2}|\/Date\([\d\-]*?\)/;
/**
* Class that extends {@link ServerCollectionViewBase} to support OData sources.
*/
export class RestCollectionViewOData extends RestCollectionView {
_url;
_tbl;
_keys;
_odv = 4; // OData Version
_pendingRequest;
/**
* Initializes a new instance of the {@link RestCollectionViewOData} class.
*
* @param url Url of the OData service (for example
* 'https://services.odata.org/Northwind/Northwind.svc/').
* @param tableName Name of the table (entity) to retrieve from the service.
* If not provided, a list of the tables (entities) available is retrieved.
* @param options JavaScript object containing initialization data (property
* values and event handlers) for the {@link ODataCollectionView}.
*/
constructor(url, tableName, options) {
super();
this._url = asString(url, false);
this._tbl = asString(tableName);
copy(this, options);
}
/**
* Gets or sets an array containing the names of the key fields.
*
* Key fields are required for update operations (add/remove/delete).
*/
get keys() {
return this._keys;
}
set keys(value) {
this._keys = asArray(value);
}
/**
* Gets or sets the OData version to use.
*/
get odataVersion() {
return this._odv;
}
set odataVersion(value) {
this._odv = asNumber(value);
}
// ** implementation
// URL handling
_getServiceUrl() {
let url = this._url;
if (url[url.length - 1] != '/') {
url += '/';
}
return url;
}
_getReadUrl(link) {
let url = this._getServiceUrl();
if (link) {
url = link.indexOf('http') == 0 ? link : url + link;
} else if (this._tbl) {
url += this._tbl;
}
return url;
}
_getWriteUrl(item) {
let url = this._getServiceUrl() + this._tbl;
if (item) {
assert(this.keys && this.keys.length > 0, 'write operations require keys.');
let keys = [];
this.keys.forEach(key => {
let itemKey = item[key];
if (itemKey == null) {
itemKey = '';
}
if (isString(itemKey)) { // enclose string keys in quotes
itemKey = '\'' + itemKey + '\'';
}
keys.push(this.keys.length == 1 // add key name only if we have multiple keys
? itemKey
: key + '=' + itemKey);
});
if (keys.length) {
url += '(' + keys.join(',') + ')';
}
}
return url;
}
// read parameters apply fields, sort, paging, and filter
_getReadParams(nextLink) {
let settings = {};
// we only do json
if (!nextLink || (nextLink.indexOf('$format') < 0 && nextLink.indexOf('%24format') < 0)) {
settings.$format = 'json';
}
// no parameters needed if they are already on the nextLink argument
if (!nextLink) {
// more setting if we have a table
if (this._tbl) {
// get filtered (but not paged) item count (OData4 uses $count, earlier versions use $inlinecount)
if (this._odv < 4) {
settings.$inlinecount = 'allpages';
} else {
settings.$count = true;
}
// specify fields to retrieve
if (this.fields) {
settings.$select = this.fields.join(',');
}
// apply sort
if (this.sortOnServer && this.sortDescriptions.length) {
let sort = '';
this.sortDescriptions.forEach(sd => {
if (sort) sort += ',';
sort += sd.property;
if (!sd.ascending) sort += ' desc';
});
settings.$orderby = sort;
}
// apply paging
if (this.pageOnServer && this.pageSize > 0) {
settings.$skip = this.pageIndex * this.pageSize;
settings.$top = this.pageSize;
}
// apply filter
if (this.filterOnServer && this._filterProvider) {
settings.$filter = this._asODataFilter(this._filterProvider);
}
}
}
return settings;
}
// parse data
_jsonReviver(key, value) {
if (typeof value === 'string' && _rxDate.test(value)) {
value = value.indexOf('/Date(') == 0 // verbosejson
? new Date(parseInt(value.substr(6)))
: new Date(value);
}
return value;
}
// gets the OData filter definition from a wijmo.grid.filter.FlexGridFilter object.
// https://www.odata.org/documentation/odata-version-2-0/uri-conventions/
_asODataFilter(filter) {
let def = '';
for (let c = 0; c < filter.grid.columns.length; c++) {
let col = filter.grid.columns[c],
cf = filter.getColumnFilter(col, false);
if (cf && cf.isActive) {
if (def) {
def += ' and ';
}
if (cf.conditionFilter && cf.conditionFilter.isActive) {
def += this._asODataConditionFilter(cf.conditionFilter);
} else if (cf.valueFilter && cf.valueFilter.isActive) {
def += this._asODataValueFilter(cf.valueFilter);
}
}
}
return def;
}
_asODataValueFilter(vf) {
let col = vf.column,
fld = col.binding,
map = col.dataMap,
def = '';
// build condition with 'eq/or'
for (let key in vf.showValues) {
let value = changeType(key, col.dataType, col.format);
if (map && isString(value)) { // TFS 239356
value = map.getKeyValue(value);
}
if (def) def += ' or ';
def += this._asEquals(fld, value, col.dataType);
}
// enclose in parenthesis if not empty
if (def.length) {
def = '(' + def + ')';
}
// all done
return def;
}
_asEquals(fld, value, type) {
let def = '',
DT = DataType;
if (value === '' || value == null) { // null or empty
def += fld + ' eq null';
if (type == DT.String) { // empty OK for strings only
def += ' or ' + fld + ' eq \'\'';
}
} else if (type == DT.Date) { // non-null/empty dates (TFS 458080)
def += fld + ' ge ' + this._asODataValue(value, type) + ' and ' +
fld + ' lt ' + this._asODataValue(DateTime.addDays(value, 1), type);
} else { // other types
def += fld + ' eq ' + this._asODataValue(value, type);
}
return '(' + def + ')';
}
_asODataConditionFilter(cf) {
let c1 = this._asODataCondition(cf, cf.condition1),
c2 = this._asODataCondition(cf, cf.condition2);
if (c1 && c2) return '(' + c1 + (cf.and ? ' and ' : ' or ') + c2 + ')';
if (c1) return '(' + c1 + ')';
if (c2) return '(' + c2 + ')';
return null;
}
_asODataCondition(cf, cnd) {
let col = cf.column,
fld = col.binding,
map = col.dataMap,
value = cnd.value;
if (map && isString(value)) { // TFS 440901
value = map.getKeyValue(value);
}
value = this._asODataValue(value, cf.column.dataType);
switch (cnd.operator) {
case 0: // EQ = 0,
return fld + ' eq ' + value;
case 1: // NE = 1,
return fld + ' ne ' + value;
case 2: // GT = 2,
return fld + ' gt ' + value;
case 3: // GE = 3,
return fld + ' ge ' + value;
case 4: // LT = 4,
return fld + ' lt ' + value;
case 5: // LE = 5,
return fld + ' le ' + value;
case 6: // BW = 6,
return 'startswith(' + fld + ',' + value + ')';
case 7: // EW = 7,
return 'endswith(' + fld + ',' + value + ')';
case 8: // CT = 8,
return this._odv >= 4
? 'contains(' + fld + ',' + value + ')' // OData4
: 'substringof(' + value.toLowerCase() + ', tolower(' + fld + '))'; // OData2
case 9: // NC = 9
return this._odv >= 4
? 'not contains(' + fld + ',' + value + ')' // OData4
: 'not substringof(' + value.toLowerCase() + ', tolower(' + fld + '))'; // OData2
}
}
_asODataValue(value, dataType) {
if (isDate(value)) {
value = value.toJSON();
if (this._odv < 4) { // TFS 323961
value = "datetime'" + value.substr(0, 10) + "'";
}
return value;
} else if (isString(value)) {
return "'" + value.replace(/'/g, "''") + "'";
} else if (value != null) {
return value.toString();
}
return dataType == DataType.String ? "''" : null;
}
// convert objects before posting to OData services
_convertToDbFormat(item) {
if (this._odv >= 4) {
return item;
}
let obj = {};
for (let key in item) {
let value = item[key];
if (isNumber(value)) {
// convert numbers to strings in versions prior to 4.0.
// failing to do this may cause the service to throw an error:
// 'Cannot convert a primitive value to the expected type'
// which can in turn causes an HTTP 400 (Bad Request) error
value = value.toString();
}
obj[key] = value;
}
return obj;
}
// ** overrides
async getItems(link) {
// cancel any pending requests
if (this._pendingRequest) {
//console.log('aborting pending request');
this._pendingRequest.abort();
}
return new Promise(resolve => {
this._pendingRequest = httpRequest(this._getReadUrl(link), {
requestHeaders: this.requestHeaders,
data: this._getReadParams(link),
success: async xhr => {
// parse response (handles OData4 and earlier)
let resp = JSON.parse(xhr.responseText, this._jsonReviver),
arr = resp.d ? resp.d.results : resp.value,
count = resp.d ? resp.d.__count : (resp['odata.count'] || resp['@odata.count']),
nextLink = resp.d ? resp.d.__next : (resp['odata.nextLink'] || resp['@odata.nextLink']);
// update total item count
if (count != null) {
this._totalItemCount = isString(count) ? parseInt(count) : count;
}
// get data from next link
if (nextLink) {
let nextPage = await this.getItems(nextLink);
arr = arr.concat(nextPage);
}
// done
resolve(arr);
},
error: xhr => this._raiseError(xhr.responseText, false),
complete: xhr => this._pendingRequest = null // no pending requests
});
});
}
addItem(item) {
// write operations require keys
if (!this.keys || !this.keys.length) {
return null;
}
return new Promise(resolve => {
let url = this._getWriteUrl();
let requestHeaders = {
'Accept': 'application/json'
};
if (this.requestHeaders) {
for (let k in this.requestHeaders) {
requestHeaders[k] = this.requestHeaders[k];
}
}
httpRequest(url, {
method: 'POST',
requestHeaders: requestHeaders,
data: this._convertToDbFormat(item),
success: xhr => { // update keys in the new item, refresh the view
let newItem = JSON.parse(xhr.responseText, this._jsonReviver);
this.keys.forEach(key => {
item[key] = newItem[key];
});
this.refresh();
},
error: xhr => this._raiseError(xhr.responseText, true)
});
});
}
patchItem(item) {
// write operations require keys
if (!this.keys || !this.keys.length) {
return null;
}
return new Promise((resolve) => {
let url = this._getWriteUrl(this._edtClone);
httpRequest(url, {
method: 'PATCH', //'PUT',
requestHeaders: this.requestHeaders,
data: this._convertToDbFormat(item),
success: xhr => resolve(item),
error: xhr => this._raiseError(xhr.responseText, true)
});
});
}
deleteItem(item) {
// write operations require keys
if (!this.keys || !this.keys.length) {
return null;
}
return new Promise(resolve => {
let url = this._getWriteUrl(item);
httpRequest(url, {
method: 'DELETE',
requestHeaders: this.requestHeaders,
success: xhr => {
resolve(item);
},
error: xhr => this._raiseError(xhr.responseText, true)
});
});
}
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
meta: {
'*.css': { loader: 'css' },
'*.vue': { loader: '../plugin-vue/index.js' }
//'*.vue': { loader: 'systemjs-plugin-vue' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'@mescius/wijmo': 'npm:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'npm:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'npm:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'npm:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'npm:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'npm:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'npm:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'npm:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'npm:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'npm:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'npm:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'npm:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'npm:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'npm:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'npm:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'npm:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'npm:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'npm:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'npm:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'npm:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'npm:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'npm:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'npm:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'npm:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'npm:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'npm:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'npm:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'npm:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'npm:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'npm:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'npm:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.nav': 'npm:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'npm:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'npm:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'npm:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'npm:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'npm:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'npm:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'npm:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'npm:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'npm:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.touch': 'npm:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'npm:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.barcode': 'npm:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'npm:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'npm:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'npm:@mescius/wijmo.barcode.specialized/index.js',
"@mescius/wijmo.vue2.chart.analytics": "npm:@mescius/wijmo.vue2.chart.analytics/index.js",
"@mescius/wijmo.vue2.chart.animation": "npm:@mescius/wijmo.vue2.chart.animation/index.js",
"@mescius/wijmo.vue2.chart.annotation": "npm:@mescius/wijmo.vue2.chart.annotation/index.js",
"@mescius/wijmo.vue2.chart.finance.analytics": "npm:@mescius/wijmo.vue2.chart.finance.analytics/index.js",
"@mescius/wijmo.vue2.chart.finance": "npm:@mescius/wijmo.vue2.chart.finance/index.js",
"@mescius/wijmo.vue2.chart.hierarchical": "npm:@mescius/wijmo.vue2.chart.hierarchical/index.js",
"@mescius/wijmo.vue2.chart.interaction": "npm:@mescius/wijmo.vue2.chart.interaction/index.js",
"@mescius/wijmo.vue2.chart.radar": "npm:@mescius/wijmo.vue2.chart.radar/index.js",
'@mescius/wijmo.vue2.chart.map': 'npm:@mescius/wijmo.vue2.chart.map/index.js',
"@mescius/wijmo.vue2.chart": "npm:@mescius/wijmo.vue2.chart/index.js",
"@mescius/wijmo.vue2.core": "npm:@mescius/wijmo.vue2.core/index.js",
"@mescius/wijmo.vue2.gauge": "npm:@mescius/wijmo.vue2.gauge/index.js",
"@mescius/wijmo.vue2.grid.detail": "npm:@mescius/wijmo.vue2.grid.detail/index.js",
"@mescius/wijmo.vue2.grid.filter": "npm:@mescius/wijmo.vue2.grid.filter/index.js",
"@mescius/wijmo.vue2.grid.grouppanel": "npm:@mescius/wijmo.vue2.grid.grouppanel/index.js",
'@mescius/wijmo.vue2.grid.search': 'npm:@mescius/wijmo.vue2.grid.search/index.js',
"@mescius/wijmo.vue2.grid.multirow": "npm:@mescius/wijmo.vue2.grid.multirow/index.js",
"@mescius/wijmo.vue2.grid.sheet": "npm:@mescius/wijmo.vue2.grid.sheet/index.js",
'@mescius/wijmo.vue2.grid.transposed': 'npm:@mescius/wijmo.vue2.grid.transposed/index.js',
'@mescius/wijmo.vue2.grid.transposedmultirow': 'npm:@mescius/wijmo.vue2.grid.transposedmultirow/index.js',
"@mescius/wijmo.vue2.grid": "npm:@mescius/wijmo.vue2.grid/index.js",
"@mescius/wijmo.vue2.input": "npm:@mescius/wijmo.vue2.input/index.js",
"@mescius/wijmo.vue2.olap": "npm:@mescius/wijmo.vue2.olap/index.js",
"@mescius/wijmo.vue2.viewer": "npm:@mescius/wijmo.vue2.viewer/index.js",
"@mescius/wijmo.vue2.nav": "npm:@mescius/wijmo.vue2.nav/index.js",
"@mescius/wijmo.vue2.base": "npm:@mescius/wijmo.vue2.base/index.js",
'@mescius/wijmo.vue2.barcode.common': 'npm:@mescius/wijmo.vue2.barcode.common/index.js',
'@mescius/wijmo.vue2.barcode.composite': 'npm:@mescius/wijmo.vue2.barcode.composite/index.js',
'@mescius/wijmo.vue2.barcode.specialized': 'npm:@mescius/wijmo.vue2.barcode.specialized/index.js',
'bootstrap.css': 'npm:bootstrap/dist/css/bootstrap.min.css',
'jszip': 'npm:jszip/dist/jszip.js',
'css': 'npm:systemjs-plugin-css/css.js',
'vue': 'npm:vue/dist/vue.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'vue-loader': 'npm:systemjs-vue-browser/index.js',
//'systemjs-plugin-vue': 'npm:systemjs-plugin-vue/index.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'js'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
wijmo: {
defaultExtension: 'js',
}
}
});
})(this);